:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
: Please use this batch file to run the sample.  Make sure that you properly  :
: set up the OSS_CSHARP_HOME and the PATH environment variables before        :
: running this script.  Nothing is required to be set if you run this sample  :
: from the OSS command prompt window.                                         :
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

@echo off
if %1. == .      goto asn1
if %1. == asn1.  goto asn1
if %1. == clean. goto clean
if %1. == help.  goto usage

echo Wrong argument '%1'.
:usage
echo Usage: run [no arguments^|asn1^|clean^|help]
exit /b 1

:asn1
echo Compiling the ASN.1 specification...
echo.
asn1cs bcas
if errorlevel 1 exit /b 1
if %1. == asn1. exit /b 0

echo.
echo Compiling generated classes into an assembly...
csc -out:tbcas.exe tbcas.cs -recurse:bcas\*.cs -r:"%OSS_CSHARP_HOME%"\bin\asn1csrt.dll
if errorlevel 1 (
    echo Error C#-compiling.
    exit /b 1
)
echo C#-compilation successful.

echo.
echo Copying asn1csrt.dll to current directory...
copy "%OSS_CSHARP_HOME%"\bin\asn1csrt.dll .
if errorlevel 1 (
    echo Error copying asn1csrt.dll.
    exit /b 1
) else (
    echo Copied asn1csrt.dll successfully.
)

echo Running the sample...
tbcas >tbcas.txt
%VIEW% tbcas.txt
exit /b 0

:clean
del *.dll                2>nul
del *.exe                2>nul
del tbcas.txt            2>nul
rmdir /q /s Bcas         2>nul
echo Cleanup done.
exit /b 0